--This file is a little weird: it runs in the Avatar entity namespace, but mostly handles the position of the camera.

maxspeed = 5
xvelocity = 0
yvelocity = 0
accel = 1
deccel = 0.8
cpos = GetCamera:GetPos()
sdim = GetApp:GetScreenSize()

function OnInit() //run upon initialization
end

function OnPostInit() //run during the entity's first logic update
  this:SetAttach(C_ENTITY_CAMERA, GetApp:GetScreenSize() / 2)

  map_edge.x = grid_snap_floor(cpos.x) - spacing
  map_edge.y = grid_snap_floor(cpos.y) - spacing

  map_dim.x = grid_snap_floor(cpos.x + sdim.x) +  spacing * 2 - map_edge.x
  map_dim.y = grid_snap_floor(cpos.y + sdim.y) + spacing * 2 - map_edge.y

  this:SetCategory(C_CATEGORY_PLAYER, true)

  GetInputManager:AddBinding("left, always", "OnLeft", this:GetID())
  GetInputManager:AddBinding("right, always", "OnRight", this:GetID())
  GetInputManager:AddBinding("up, always", "OnUp", this:GetID())
  GetInputManager:AddBinding("down, always", "OnDown", this:GetID())

  ResetKeys()
  this:SetRunUpdateEveryFrame(true)

  draw_map(map_edge.x, map_edge.y, 
    map_edge.x - map_dim.x, map_edge.y - map_dim.y,
    map_dim.x, map_dim.y)
end

function OnKill() //run when removed
end

function Update(step)
  move()
  check_bounds()
end

function move()
  if (m_bLeft) then
    xvelocity = xvelocity - accel
    else if (m_bRight) then
      xvelocity = xvelocity + accel
    end
  end
  
  if (m_bUp) then 
    yvelocity = yvelocity - accel
    else if (m_bDown) then
      yvelocity = yvelocity + accel
    end
  end

  if math.abs(yvelocity) < 0.5 then
    yvelocity = 0
  else
    yvelocity = yvelocity / math.abs(yvelocity) * math.min(math.abs(yvelocity), maxspeed)
  end
  if math.abs(xvelocity) < 0.5 then
    xvelocity = 0
  else
    xvelocity = xvelocity / math.abs(xvelocity) * math.min(math.abs(xvelocity), maxspeed)
  end

  GetCamera:SetPos(GetCamera:GetPos() + Vector2(xvelocity, yvelocity))

  xvelocity = xvelocity * deccel
  yvelocity = yvelocity * deccel
end

function check_bounds()
  local old_edge = {}

  if (cpos.y < map_edge.y + spacing) or
     (cpos.y + sdim.y > map_edge.y + map_dim.y - spacing) or
     (cpos.x < map_edge.x + spacing) or
     (cpos.x + sdim.x > map_edge.x + map_dim.x - spacing) then

    old_edge.x = map_edge.x
    old_edge.y = map_edge.y
    map_edge.x = grid_snap_floor(cpos.x) - spacing
    map_edge.y = grid_snap_floor(cpos.y) - spacing

    draw_map(map_edge.x, map_edge.y, old_edge.x, old_edge.y, map_dim.x, map_dim.y)
  end
end

function ResetKeys()
  m_bLeft = false
  m_bRight = false
  m_bUp = false
  m_bDown = false
end

function OnLeft(bKeyDown)
  m_bLeft = bKeyDown
  return true
end

function OnRight (bKeyDown)
  m_bRight = bKeyDown
  return true
end

function OnUp(bKeyDown)
  m_bUp = bKeyDown
  return true
end

function OnDown(bKeyDown)
  m_bDown = bKeyDown
  return true
end
