function OnInit() //run upon initialization
end

function OnPostInit() //run during the entity's first logic update
  --disable physical response to collisions
  this:SetCollisionCategories(C_CATEGORIES_NONE)
  this:SetCollisionListenCategory(C_CATEGORY_PLAYER, true)
  local c_index_x = math.abs(this:GetPos().x) / spacing
  local c_index_y = math.abs(this:GetPos().y) / spacing
  local color = colors[math.floor(c_index_x + c_index_y) % 6 + 1]
  this:SetBaseColor(Color(color[1], color[2], color[3], 255))
  this:SetRunUpdateEveryFrame(true)
end

function Update(step)
  if (this:GetPos().x > map_edge.x + map_dim.x - spacing) or
     (this:GetPos().x < map_edge.x) or
     (this:GetPos().y > map_edge.y + map_dim.y - spacing) or
     (this:GetPos().y < map_edge.y) then
    this:SetDeleteFlag(true)
  end
end

function OnCollision(vPosition, vVelocity, vNormal, depth, materialID, entity, state)
  local x = this:GetPos().x
  local y = this:GetPos().y
  if not eaten[x] then
    eaten[x] = {}
  end
  eaten[x][y] = 1
  this:SetDeleteFlag(true)
end

function OnKill() //run when removed
end

